require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ARCH_X86_64_ATOMIC__)) {
    eval 'sub __ARCH_X86_64_ATOMIC__ () {1;}' unless defined(&__ARCH_X86_64_ATOMIC__);
    require 'linux/config.ph';
    require 'asm/types.ph';
    if(defined(&CONFIG_SMP)) {
	eval 'sub LOCK () {"lock ; ";}' unless defined(&LOCK);
    } else {
	eval 'sub LOCK () {"";}' unless defined(&LOCK);
    }
    eval 'sub ATOMIC_INIT {
        local($i) = @_;
	    eval q({ ($i) });
    }' unless defined(&ATOMIC_INIT);
    eval 'sub atomic_read {
        local($v) = @_;
	    eval q((($v)-> &counter));
    }' unless defined(&atomic_read);
    eval 'sub atomic_set {
        local($v,$i) = @_;
	    eval q(((($v)-> &counter) = ($i)));
    }' unless defined(&atomic_set);
    eval 'sub atomic_inc_return {
        local($v) = @_;
	    eval q(( &atomic_add_return(1,$v)));
    }' unless defined(&atomic_inc_return);
    eval 'sub atomic_dec_return {
        local($v) = @_;
	    eval q(( &atomic_sub_return(1,$v)));
    }' unless defined(&atomic_dec_return);
    eval 'sub ATOMIC64_INIT {
        local($i) = @_;
	    eval q({ ($i) });
    }' unless defined(&ATOMIC64_INIT);
    eval 'sub atomic64_read {
        local($v) = @_;
	    eval q((($v)-> &counter));
    }' unless defined(&atomic64_read);
    eval 'sub atomic64_set {
        local($v,$i) = @_;
	    eval q(((($v)-> &counter) = ($i)));
    }' unless defined(&atomic64_set);
    eval 'sub atomic64_inc_return {
        local($v) = @_;
	    eval q(( &atomic64_add_return(1,$v)));
    }' unless defined(&atomic64_inc_return);
    eval 'sub atomic64_dec_return {
        local($v) = @_;
	    eval q(( &atomic64_sub_return(1,$v)));
    }' unless defined(&atomic64_dec_return);
    eval 'sub atomic_cmpxchg {
        local($v, $old, $new) = @_;
	    eval q(( &cmpxchg((($v)-> &counter), $old, $new)));
    }' unless defined(&atomic_cmpxchg);
    eval 'sub atomic_xchg {
        local($v, $new) = @_;
	    eval q(( &xchg((($v)-> &counter), $new)));
    }' unless defined(&atomic_xchg);
    eval 'sub atomic_add_unless {
        local($v, $a, $u) = @_;
	    eval q(({ \'int\'  &c,  &old;  &c =  &atomic_read($v);  &while ( &c != ($u)  && ( &old =  &atomic_cmpxchg(($v),  &c,  &c + ($a))) !=  &c)  &c =  &old;  &c != ($u); }));
    }' unless defined(&atomic_add_unless);
    eval 'sub atomic_inc_not_zero {
        local($v) = @_;
	    eval q( &atomic_add_unless(($v), 1, 0));
    }' unless defined(&atomic_inc_not_zero);
    eval 'sub atomic_clear_mask {
        local($mask, $addr) = @_;
	    eval q( &__asm__  &__volatile__( &LOCK \\"andl %0,%1\\" : : \\"r\\" (~($mask)),\\"m\\" (*$addr) : \\"memory\\"));
    }' unless defined(&atomic_clear_mask);
    eval 'sub atomic_set_mask {
        local($mask, $addr) = @_;
	    eval q( &__asm__  &__volatile__( &LOCK \\"orl %0,%1\\" : : \\"r\\" ($mask),\\"m\\" (*($addr)) : \\"memory\\"));
    }' unless defined(&atomic_set_mask);
    eval 'sub smp_mb__before_atomic_dec () {
        eval q( &barrier());
    }' unless defined(&smp_mb__before_atomic_dec);
    eval 'sub smp_mb__after_atomic_dec () {
        eval q( &barrier());
    }' unless defined(&smp_mb__after_atomic_dec);
    eval 'sub smp_mb__before_atomic_inc () {
        eval q( &barrier());
    }' unless defined(&smp_mb__before_atomic_inc);
    eval 'sub smp_mb__after_atomic_inc () {
        eval q( &barrier());
    }' unless defined(&smp_mb__after_atomic_inc);
    require 'asm-generic/atomic.ph';
}
1;
